#include <stdio.h>
#include <stream.h>




#include "ModelInvPts.h"
#include <stdlib.h>

#define NUM_PTS 1000000
//Extern global variable
extern int ErrorFlag;
FILE  *open_file( char *file);

static float _PtsArray[NUM_PTS][3];
static int _num_pts=0;

//Functions of this module
// int
// read_seq_of_points(Model *&theModel, FILE *fpts, int numPtsToRead);
int
read_seq_of_pointsCYRA(Model *&theModel, FILE *fpts);
// int
// read_seq_of_pointsCYRA_wTRANSF(Model *&theModel, FILE *fpts, int numPtsToRead);


//Reads a sequence of points from the file fpts and updates the model Model
//Returns 0 if EOF reached
//Returns -1 is exceeded max num of pts (NUM_PTS)
//Return 1 otherwise
//_PtsArray static global array
//_num_pts current number of points the array holds

void
reset_seq_of_points()
{
    _num_pts=0;
}

// int
// read_seq_of_points(Model *&theModel, FILE *fpts, int numPtsToRead)
// {
//     int _ptsRead=0;
//     float x, y, z;
//     if (numPtsToRead==0) numPtsToRead=NUM_PTS; //If 0 read all

//     while (_ptsRead < numPtsToRead){
// 	if (fscanf(fpts, "%f %f %f", &x, &y, &z)!=EOF){
// 	    if (_num_pts>=NUM_PTS ) {
// 		printf("Too many points...\n");
// 		theModel->addPoints( _PtsArray, _num_pts);
// 		return -1;
// 	    }
// 	    _PtsArray[_num_pts][0] = x;
// 	    _PtsArray[_num_pts][1] = y;
// 	    _PtsArray[_num_pts][2] = z;
// 	    ++_num_pts; //Total num of pts
// 	    ++_ptsRead; //Total points read in this function call
// 	} else {
// 	    printf("Reached EOF\n");
// 	    theModel->addPoints(_PtsArray, _num_pts);
// 	    printf("READ %d POINTS\n", _ptsRead);
// 	    return 0;
// 	}
//     }
//     theModel->addPoints( _PtsArray, _num_pts);

//     return 1;
// }


// //points have a 4th coordinate
// int
// read_seq_of_points2(Model *&theModel, FILE *fpts, int numPtsToRead)
// {
//     int _ptsRead=0;
//     float x, y, z, laser_int;
//     if (numPtsToRead==0) numPtsToRead=NUM_PTS; //If 0 read all

//     while (_ptsRead < numPtsToRead){
// 	if (fscanf(fpts, "%f %f %f %f", &x, &y, &z, &laser_int)!=EOF){
// 	    if (_num_pts>=NUM_PTS ) {
// 		printf("Too many points...\n");
// 		theModel->addPoints( _PtsArray, _num_pts);
// 		return -1;
// 	    }
// 	    if (x!=0 || y!=0 || z!=0) { //Do not display (0,0,0) points
// 	      _PtsArray[_num_pts][0] = x;
// 	      _PtsArray[_num_pts][1] = y;
// 	      _PtsArray[_num_pts][2] = z;
// 	      ++_num_pts; //Total num of pts
// 	      ++_ptsRead; //Total points read in this function call
// 	    }
// 	} else {
// 	    printf("Reached EOF\n");
// 	    theModel->addPoints(_PtsArray, _num_pts);
// 	    printf("READ %d POINTS\n", _ptsRead);
// 	    return 0;
// 	}
//     }
//     theModel->addPoints( _PtsArray, _num_pts);

//     return 1;
// }

int
read_seq_of_pointsCYRA(Model *&theModel, FILE *fpts)
{
    int _ptsRead=0;
    float x, y, z, dump;
    int nr, nc; //read but do not use
    int numPtsToRead=NUM_PTS; //If 0 read all

    fscanf(fpts, "%d\n", &nr);
    fscanf(fpts, "%d\n", &nc);


    while (_ptsRead < numPtsToRead){
	if (fscanf(fpts, "%f %f %f %f", &x, &y, &z, &dump)!=EOF){
	    if (_num_pts>=NUM_PTS ) {
		printf("Too many points...\n");
		theModel->addPoints( _PtsArray, _num_pts);
		return -1;
	    }
	    _PtsArray[_num_pts][0] = x;
	    _PtsArray[_num_pts][1] = y;
	    _PtsArray[_num_pts][2] = z;
	    ++_num_pts; //Total num of pts
	    ++_ptsRead; //Total points read in this function call
	} else {
	    printf("Reached EOF\n");
	    theModel->addPoints(_PtsArray, _num_pts);

	    return 0;
	}
    }
    theModel->addPoints( _PtsArray, _num_pts);

    return 1;
}

// int
// read_seq_of_pointsCYRA_wTRANSF(Model *&theModel, FILE *fpts, int numPtsToRead)
// {
//     int _ptsRead=0;
//     float x, y, z, dump;
//     int nr, nc; //read but do not use
//     if (numPtsToRead==0) numPtsToRead=NUM_PTS; //If 0 read all

//     fscanf(fpts, "%d\n", &nr);
//     fscanf(fpts, "%d\n", &nc);
//     float t1, t2, t3, t4;
//     int i;
//     for (i=0; i<4; ++i)
//       fscanf(fpts, "%lf %lf %lf\n", &t1, &t2, &t3);
//     for (i=0; i<4; ++i)
//       fscanf(fpts, "%lf %lf %lf %lf\n", &t1, &t2, &t3, &t4);

//     while (_ptsRead < numPtsToRead){
// 	if (fscanf(fpts, "%f %f %f %f", &x, &y, &z, &dump)!=EOF){
// 	    if (_num_pts>=NUM_PTS ) {
// 		printf("Too many points...\n");
// 		theModel->addPoints( _PtsArray, _num_pts);
// 		return -1;
// 	    }
// 	    _PtsArray[_num_pts][0] = x;
// 	    _PtsArray[_num_pts][1] = y;
// 	    _PtsArray[_num_pts][2] = z;
// 	    ++_num_pts; //Total num of pts
// 	    ++_ptsRead; //Total points read in this function call
// 	} else {
// 	    printf("Reached EOF\n");
// 	    theModel->addPoints(_PtsArray, _num_pts);

// 	    return 0;
// 	}
//     }
//     theModel->addPoints( _PtsArray, _num_pts);

//     return 1;
// }




FILE *open_file( char *name)
{
    FILE *fd;
    if ((fd = fopen(name,"w+"))
	== NULL) {
	printf("could't open  file %s\n", name);
	return NULL;
    }
    else {
	return fd;
    }

}
